#!/bin/csh

# First script: to create control files

setenv ORACLE_PSRV MCI
setenv USER mci
#setenv USER bench

date

if( $#argv != 4 ) then 
	echo Usage: create_ctl.sh scale_factor no_tables_to_run no_instances table_name
	exit
endif

if( $argv[4] != 'lineitem' && $argv[4] != 'order' && $argv[4] != 'customer' && \
$argv[4] != 'partsupp' && $argv[4] != 'part' && $argv[4] != 'supplier' ) then
 echo " "
 echo error in create_ctl.sh. invalid table name $argv[4].
 echo " "
 exit
endif

date

setenv DATADIR /raw/rawdata$argv[1]
setenv LOGDIR /usr/mci/load/outsf$argv[1]

if( ! -e $LOGDIR ) mkdir /usr/mci/load/outsf$1

set filelist = $argv[4]
set filecount = $argv[2]
set ninst = $argv[3]

if( $argv[1] < $argv[2] ) set inc = 0
if( $argv[1] >= $argv[2] ) set inc = 1
if( $ninst >= $argv[2] ) then
@ nfpl = 1
else
@ nfpl = $argv[2] / $ninst
endif

set j = 0
set k = 1
set m = 1

echo filecount = $filecount, ninst = $ninst

#Create control files for a set of input tables

while( $m <= $ninst )
 setenv ORACLE_SID $ORACLE_PSRV$m
 echo LOAD DATA > $LOGDIR/$filelist.ctl$m
@ s = 1
l4:
 if( $s <= $nfpl ) then
@ j=$j + $inc
  echo "INFILE '$DATADIR/$filelist.tbl$j' BADFILE '$LOGDIR/$filelist.$j.bad'" >> $LOGDIR/$filelist.ctl$m
@ s++
  goto l4
 endif
 echo APPEND >> $LOGDIR/$filelist.ctl$m
 cat $LOGDIR/../$filelist.ctl >> $LOGDIR/$filelist.ctl$m
 echo control file created  -- $filelist.ctl$m 
 echo " "
@ m++
end

date

